#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
class aprobesender;
struct aprobesenderHdr
{
	int NumPacks_;
	int packetSize_;
	double interval_;
	double SpreadFactor_;	
	double WaitInterval_;
	double sendtime_;
	double packetnumber_;
	double Max_rate_;
	int type;  //packet belongs to train or stream 1 train 2 stream
//Header Access Methods
	static int offset_;
	inline static int& offset() {return offset_;}
	inline static aprobesenderHdr* access(const Packet *p)
	{ return(aprobesenderHdr*) p->access(offset_); }
};

struct aprobereceiverHdr
{
        double sendtime_;
        int ack_;// Acknowledges the complete rx of a certin numbered fleet
        int newPacketSize_;  //Tells sender of what is the next packet size to use
        int responseType_ ; // 1 reponse to train 2 response to fleet
        double feedback_ ; //Feedback to rx .. usually new sx rate
        int loss_;    // set if loss observed
        int terminate_; // end the measurement and report the abw
//Header Access Methods        
        static int offset_;
        inline static int& offset() {return offset_;}
        inline static aprobereceiverHdr* access(const Packet *p)
        { return(aprobereceiverHdr*) p->access(offset_); }
};


class aprobesndtimer:public TimerHandler
{
	public:
		aprobesndtimer(aprobesender *a): TimerHandler() {a_=a;}
//	protected:
		virtual void expire(Event *e);
		aprobesender *a_;
};

class aprobesender:public Agent
{
	public:
		//Function Declarations
		aprobesender();
		virtual int command(int argc,const char*const* argv);
		virtual void timeout(int);
		virtual void recv(Packet*,Handler*);
		void sendpacket(int);
		void start();
		void sendtrain(int);
		
		//External Variables
		int NumPacks_;
		int packetSize_;
		double interval_;
		double SpreadFactor_;	
		double WaitInterval_;
		double sendtime_;
		double packetnumber_;
		double Max_rate_;
                aprobesndtimer timer_;        //Timer for mainitaing the clock
		
		//Internal Variables 
		double currinterval;  //interval at which packets are being sent
		int pktcounter;    // counter for packet numbers
		int status; // Status flag 1 for train; 2 for fleet; 0 for waiting for input from rx 
		int fleetcounter;  //Counter which counts the number of fleets sent
};

