#include "pktreceiver.h"
int cprobereceiverHdr::offset_;
static class cprobereceiverHdrClass: public PacketHeaderClass
{
        public:
        cprobereceiverHdrClass(): PacketHeaderClass("PacketHeader/cprobe_rcvr",sizeof(cprobereceiverHdrClass))
        {
                bind_offset(&cprobereceiverHdr::offset_);
        }

}class_cprobereceiverHdr;

static class cprobereceiverClass: public TclClass
{
	public:
		cprobereceiverClass():TclClass("Agent/cprobe_rcvr"){}
		TclObject* create(int,const char*const*)
		{
			return (new cprobereceiver());
		}
}class_cprobereceiver;

cprobereceiver::cprobereceiver():Agent(PT_CPROBERCVR)
{
	bind("interval_",&interval_);
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
	// This has no role so far
	bind("samples_for_ab_",&samples_for_ab_);  
	bind("decrease_factor_",&decrease_factor_);
	bind("Excursion_Threshold_",&Excursion_Threshold_);
	bind("BinWidth_",&BinWidth_);
	bind("GapDiffIgnore_",&GapDiffIgnore_);
	bind("Resolution_",&Resolution_);
	fleetcounter=0;
	CurrentAb=0;
	//BinWidth_=.000025;
	//GapDiffIgnore_=.000010;
	//Resolution_=500000;
	state=1;
}

int cprobereceiver::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

int cprobereceiver::start()
{
	packetSize_=size_;
}

void cprobereceiver::recv(Packet *pkt,Handler*)
{
	hdr_ip* hdrip = hdr_ip::access(pkt);
	cprobesenderHdr *h=cprobesenderHdr::access(pkt);
	int index=(int)h->packetnumber_;
 	double spread=h->SpreadFactor_;
	double interval_=h->interval_;
	int spacketsize=h->packetSize_;
	senderPacks_=h->NumPacks_;
	LinkCapacity=h->Max_rate_;
	int ptype=h->type;
	//fprintf(stdout," Recd Packet \n");
	// This is the data collection part
	if(h->packetnumber_==0)
	{
		allocatemem();
		rcv_time[index]=Scheduler::instance().clock();	
		snd_time[index]=h->sendtime_;
		qing_delay[index]=rcv_time[index]-(h->sendtime_);
	}
	else
	{
		snd_time[index]=h->sendtime_;
		rcv_time[index]=Scheduler::instance().clock();	
		qing_delay[index]=rcv_time[index]-(h->sendtime_);	
		iat[index]=qing_delay[index]-qing_delay[index-1];
		rates[index]= (double)((8*spacketsize)/(interval_))/1000000;
	}
	// End data collection part
	
	//Inference Logic Part here 
	//One entire probe stream recd
	double feedback;
	if(h->packetnumber_==(senderPacks_-1))
	{
		// Use the receiving rate of this stream as the available bandwidth
		double stream_time=rcv_time[(int)(senderPacks_-1)]-rcv_time[0];
		double abw=(senderPacks_*8*spacketsize)/stream_time;
		double rctime=Scheduler::instance().clock();
		fprintf(stdout,"%lf Available Bandwidth is %lf \n",rctime,abw);
		reset();
		freemem();
	}
	Packet::free(pkt);
}

void cprobereceiver::allocatemem()
{
	int Esqrt=(int)sqrt(senderPacks_);
	qing_delay=(double *) calloc((int)(senderPacks_),sizeof(double));
	rates=(double *) calloc((int)(senderPacks_),sizeof(double));
	iat=(double *) calloc((int)(senderPacks_),sizeof(double));
	av_bw_per_pkt=(double *) calloc((int)(senderPacks_),sizeof(double));
	snd_time=(double *) calloc((int)(senderPacks_),sizeof(double));
	rcv_time=(double *) calloc((int)(senderPacks_),sizeof(double));
	//ordered=(double *) calloc((int)(Esqrt),sizeof(double));
}	

void cprobereceiver::freemem()
{
	free(qing_delay);
	free(rates);
	free(iat);
	free(av_bw_per_pkt);
	//free(ordered);
}

void cprobereceiver::reset()
{
	fleetcounter=0;
	CurrentAb=0;
	state=1;
	BottleneckBW=0;
}
