#include "pktsender.h"
int cprobesenderHdr::offset_;
static class cprobesenderHdrClass: public PacketHeaderClass
{
	public:
	cprobesenderHdrClass(): PacketHeaderClass("PacketHeader/cprobe_sndr",sizeof(cprobesenderHdrClass))
	{
		bind_offset(&cprobesenderHdr::offset_);
	}

}class_cprobesenderHdr;

static class cprobesenderClass: public TclClass
{
	public:
		cprobesenderClass():TclClass("Agent/cprobe_sndr"){}
		TclObject* create(int,const char*const*)
		{
			return (new cprobesender());
		}
}class_cprobesender;

cprobesender::cprobesender():Agent(PT_CPROBESNDR),timer_(this)
{
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
   	bind("interval_",&interval_);
   	bind("SpreadFactor_",&SpreadFactor_);
   	bind("WaitInterval_",&WaitInterval_);
	bind("Max_rate_",&Max_rate_);
	pktcounter=0;
	fleetcounter=0;
}

int cprobesender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void cprobesender::start()
{
	packetSize_=size_;   				//Store the max packet size in packetSize_
	size_=packetSize_;   				//Set packetsize to be max packet size
	currinterval=((packetSize_*8)/(Max_rate_));	// Interval for Maximum Rate	
	fprintf(stdout,"Current Interval %lf \n",currinterval);
	status=1;
	timeout(0);
}

void cprobesender::timeout(int)
{
	if(status==1)
	{
		sendtrain(1);  //Send with train flag set
	}
	return ;
}

void cprobesender::sendtrain(int type)
{
	sendpacket(type);
	pktcounter++;
	if(pktcounter==NumPacks_)
	{
		pktcounter=0;
		//status=1;
		timer_.resched(WaitInterval_);
		 
	}
	else
	{
		timer_.resched(currinterval);
	}
	return;
}

void cprobesender::sendpacket(int typepack)
{
	Packet *p=allocpkt();
	cprobesenderHdr *hdr=cprobesenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
	hdr->NumPacks_=NumPacks_; 
	hdr->packetSize_=size_;
	hdr->interval_=currinterval;
	hdr->SpreadFactor_=SpreadFactor_;
	hdr->Max_rate_=Max_rate_;
	hdr->WaitInterval_=WaitInterval_;
	hdr->packetnumber_=pktcounter;
	hdr->type=typepack;
	send(p,0);
	return;
}

void cprobesndtimer::expire(Event *e)
{
	a_->timeout(0);
}
