#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include <math.h>
class igireceiver;
struct igisenderHdr
{
        int NumPacks_;
        int packetSize_;
        double interval_;
        double SpreadFactor_;
        double WaitInterval_;
        double sendtime_;
        double packetnumber_;
        double Max_rate_;
        int type;  //packet belongs to train or stream 1 train 2 stream
//Header Access Methods
        static int offset_;
        inline static int& offset() {return offset_;}
        inline static igisenderHdr* access(const Packet *p)
        { return(igisenderHdr*) p->access(offset_); }
};

struct igireceiverHdr
{
	double sendtime_;
	int ack_;// Acknowledges the complete rx of a certin numbered fleet
	int newPacketSize_;  //Tells sender of what is the next packet size to use
	int responseType_ ; // 1 reponse to train 2 response to fleet
	double feedback_ ; //Feedback to sx .. usually new sx rate
	int loss_;    // set if loss observed
	int terminate_; // end the measurement and report the abw
//Header Access Methods
	static int offset_;
	inline static int& offset() {return offset_;}
	inline static igireceiverHdr* access(const Packet *p)
	{ return(igireceiverHdr*) p->access(offset_); }
};

class igireceiver:public Agent
{
	public:
	//Function Declarations
		igireceiver();
		virtual int start();
		virtual int command(int argc,const char*const* argv);
		virtual void recv(Packet*,Handler*); 
		void allocatemem();
		void freemem(); 
		double computeadr(int);
		double computeavabw();
		void sendresponse(double,int);
		double computeBottleneck(int);
		double findRange();
		double Converge();
		double avrSrcGap();
		double avrDstGap();
		double Comp(double,double);
		void reset();
	//External Variables
		double interval_;   	// Set by sender
		int NumPacks_; 		// Set by user.. should correlate with sender 
		int packetSize_;	// Set by user this is the packet size of returning packet
		double BinWidth_; // For binning algorithm
		double GapDiffIgnore_;  // Gap Difference values that can be considered to be the same
		double Resolution_;	  // Resolution to say that AB reached.
		double decrease_factor_;
		double samples_for_ab_;
		double Excursion_Threshold_;
	//Internal Variables	
		int fleetcounter;
		int EnSquared;
		int state; 		//State 1,2,3
		double *qing_delay;
		double *rates;
		double *iat;
		double *av_bw_per_pkt;
		double *snd_time;
		double *rcv_time;
		double *value;
		double *count;	
		double *gaps;
		double senderPacks_;  	//Set by the sender
		double LinkCapacity; 
		double CurrentAb;	//Store the average AB
		double BottleneckBW;
		double CurrentRate;
		double LowerRate;
		double UpperRate;
		double avr_src_gap;
		double avr_dst_gap;
};
