#include "pktsender.h"

int igisenderHdr::offset_;
static class igisenderHdrClass: public PacketHeaderClass
{
	public:
	igisenderHdrClass(): PacketHeaderClass("PacketHeader/igi_sndr",sizeof(igisenderHdrClass))
	{
		bind_offset(&igisenderHdr::offset_);
	}

}class_igisenderHdr;

static class igisenderClass: public TclClass
{
	public:
		igisenderClass():TclClass("Agent/igi_sndr"){}
		TclObject* create(int,const char*const*)
		{
			return (new igisender());
		}
}class_igisender;

igisender::igisender():Agent(PT_IGISNDR),timer_(this)
{
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
   	bind("interval_",&interval_);
   	bind("SpreadFactor_",&SpreadFactor_);
   	bind("WaitInterval_",&WaitInterval_);
	bind("Max_rate_",&Max_rate_);
	bind("MT_",&MT_);
	pktcounter=0;
	fleetcounter=0;
}

int igisender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void igisender::start()
{
	packetSize_=size_;   				//Store the max packet size in packetSize_
	size_=packetSize_;   				//Set packetsize to be max packet size
	// Computing the stream parameters 
	fprintf(stdout,"Current Interval Pack %d Num %d %lf \n",size_,NumPacks_,currinterval);
	int PackSize=(int)(MT_*Max_rate_)/(NumPacks_*8);
	fprintf(stdout,"SenderMod::Current Interval Pack %d Num %d %lf \n",PackSize,NumPacks_,currinterval);
        if (PackSize<96)
        {
                PackSize=96;
                int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
                NumPacks_=numpacks; 
	}
        if (PackSize>8192)
        {
                PackSize=8192;
                int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
                NumPacks_=numpacks;
        }
        size_=PackSize;
        currinterval=((size_*8)/(Max_rate_));   // Interval for Maximum Rate
	fprintf(stdout,"SenderMod::Current Interval Pack %d Num %d %lf \n",size_,NumPacks_,currinterval);
	status=1;
	timeout(0);
}

void igisender::timeout(int)
{
	if(status==1)
	{
		sendtrain(1);  //Send with train flag set
	}
	return ;
}

void igisender::sendtrain(int type)
{
	sendpacket(type);
	pktcounter++;
	if(pktcounter==NumPacks_)
	{
		fprintf(stdout," Train Sent \n\n");
		pktcounter=0;
		status=0;
	}
	else
	{
		timer_.resched(currinterval);
	}
	return;
}

void igisender::sendpacket(int typepack)
{
	Packet *p=allocpkt();
	igisenderHdr *hdr=igisenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
	hdr->NumPacks_=NumPacks_; 
	hdr->packetSize_=size_;
	hdr->interval_=currinterval;
	hdr->SpreadFactor_=SpreadFactor_;
	hdr->Max_rate_=Max_rate_;
	hdr->WaitInterval_=WaitInterval_;
	hdr->packetnumber_=pktcounter;
	hdr->type=typepack;
	send(p,0);
	return;
}

//The receiver module
void igisender::recv(Packet *pkt ,Handler*)
{
	// this is where a response will come back .. 
	hdr_ip* hdrip = hdr_ip::access(pkt);
	igireceiverHdr *h=igireceiverHdr::access(pkt);
	double fb=h->feedback_;
	fprintf(stdout," SenderMod::Received packet back and the feedback is %lf \n",fb);
	if(fb!=-1)
	{
		status=1;
		packetSize_=size_;   				//Store the max packet size in packetSize_
		size_=packetSize_;   				//Set packetsize to be max packet size
		// Computing the stream parameters 
		int PackSize=(int)(MT_*fb)/(NumPacks_*8);
        	if (PackSize<96)
        	{
                	PackSize=96;
                	int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
                	NumPacks_=numpacks; 
		}
        	if (PackSize>8192)
        	{
                	PackSize=8192;
                	int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
                	NumPacks_=numpacks;
        	}
        	size_=PackSize;
		currinterval=((size_*8)/(fb));	// Interval for Maximum Rate	
		fprintf(stdout,"SenderMod::Current Interval Pack %d Num %d %lf \n",size_,NumPacks_,currinterval);
		sendtrain(1);
	}
	else
	{
		pktcounter=0;
	   	fleetcounter=0;
		start();
	}
	return;		
}

void igisndtimer::expire(Event *e)
{
	a_->timeout(0);
}
