#include "pktsender.h"

int igiorigsenderHdr::offset_;
static class igiorigsenderHdrClass: public PacketHeaderClass
{
	public:
	igiorigsenderHdrClass(): PacketHeaderClass("PacketHeader/igiorig_sndr",sizeof(igiorigsenderHdrClass))
	{
		bind_offset(&igiorigsenderHdr::offset_);
	}

}class_igiorigsenderHdr;

static class igiorigsenderClass: public TclClass
{
	public:
		igiorigsenderClass():TclClass("Agent/igiorig_sndr"){}
		TclObject* create(int,const char*const*)
		{
			return (new igiorigsender());
		}
}class_igiorigsender;

igiorigsender::igiorigsender():Agent(PT_IGIORIGSNDR),timer_(this)
{
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
   bind("interval_",&interval_);
   bind("SpreadFactor_",&SpreadFactor_);
   bind("WaitInterval_",&WaitInterval_);
	bind("Max_rate_",&Max_rate_);
	pktcounter=0;
	fleetcounter=0;
}

int igiorigsender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void igiorigsender::start()
{
	packetSize_=size_;   				//Store the max packet size in packetSize_
	size_=packetSize_;   				//Set packetsize to be max packet size
	currinterval=((packetSize_*8)/(Max_rate_));	// Interval for Maximum Rate	
	fprintf(stdout,"Current Interval %lf \n",currinterval);
	status=1;
	timeout(0);
}

void igiorigsender::timeout(int)
{
	if(status==1)
	{
		sendtrain(1);  //Send with train flag set
	}
	return ;
}

void igiorigsender::sendtrain(int type)
{
	sendpacket(type);
	pktcounter++;
	if(pktcounter==NumPacks_)
	{
		pktcounter=0;
		status=0;
		 
	}
	else
	{
		timer_.resched(currinterval);
	}
	return;
}

void igiorigsender::sendpacket(int typepack)
{
	Packet *p=allocpkt();
	igiorigsenderHdr *hdr=igiorigsenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
	hdr->NumPacks_=NumPacks_; 
	hdr->packetSize_=size_;
	hdr->interval_=currinterval;
	hdr->SpreadFactor_=SpreadFactor_;
	hdr->Max_rate_=Max_rate_;
	hdr->WaitInterval_=WaitInterval_;
	hdr->packetnumber_=pktcounter;
	hdr->type=typepack;
	send(p,0);
	return;
}

//The receiver module
void igiorigsender::recv(Packet *pkt ,Handler*)
{
	// this is where a response will come back .. 
	hdr_ip* hdrip = hdr_ip::access(pkt);
	igiorigreceiverHdr *h=igiorigreceiverHdr::access(pkt);
	double fb=h->feedback_;
	fprintf(stdout," Received packet back and the feedback is %lf \n",fb);
	if(fb!=-1)
	{
		status=1;
		currinterval=((packetSize_*8)/(fb));	// Interval for Maximum Rate	
		sendtrain(1);
	}
	else
	{
		pktcounter=0;
	   fleetcounter=0;
		start();
	}
	return;		
}

void igiorigsndtimer::expire(Event *e)
{
	a_->timeout(0);
}
