#include "pktsender.h"

int pktsenderHdr::offset_;
static class pktsenderHdrClass: public PacketHeaderClass
{
	public:
	pktsenderHdrClass(): PacketHeaderClass("PacketHeader/pktsender",sizeof(pktsenderHdrClass))
	{
		bind_offset(&pktsenderHdr::offset_);
	}

}class_pktsenderHdr;

static class pktsenderClass: public TclClass
{
	public:
		pktsenderClass():TclClass("Agent/pktsender"){}
		TclObject* create(int,const char*const*)
		{
			return (new pktsender());
		}
}class_pktsender;

pktsender::pktsender():Agent(PT_PKTSENDER),timer_(this)
{
	bind("packetSize_",&size_);
	bind("SpreadFactor_",&SpreadFactor_);
	bind("MaxRate_",&MaxRate_);
	bind("MinRate_",&MinRate_);
	bind("WaitInterval_",&WaitInterval_);
	//Not Goin to Use
	bind("NumPacks_",&NumPacks_);
	bind("interval_",&interval_);// Set by computing
	pktcounter=0;
}

int pktsender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			// Setting Up Interval with Minimum Rate
			fprintf(stdout," Hello World ");
			StartInterval=(size_*8)/(MinRate_);
			EndInterval=(size_*8)/(MaxRate_);
			interval_=StartInterval;
			fprintf(stdout," Rates %lf %lf \n",StartInterval,EndInterval);
			timeout(0);
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void pktsender::timeout(int)
{
	packetSize_=size_;
	sendpacket();
	pktcounter++;
	//fprintf(stdout," Sent %lf and %lf \n",interval_,EndInterval);
	if(interval_<=EndInterval)
	{
		//Inside this condition means that All the rates from Start
		//To End Rate have been probed at
		//Set the Interval to the Largest interval 
		fprintf(stdout,"Chirp Sent  \n");
		interval_=(size_*8)/(MinRate_);
		timer_.resched(WaitInterval_);
		pktcounter=0;
	}
	else
	{
		//During the sending of a Chirp
		double decrease=1;
		// Computing the new gap
		for(int i=0;i<(pktcounter-1);i++)
		{
			decrease=decrease*SpreadFactor_;	
		}
		interval_ = StartInterval*decrease;	
		timer_.resched(interval_);
	}
}

void pktsender::sendpacket()
{
	Packet *p=allocpkt();
	pktsenderHdr *hdr=pktsenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
	hdr->packetnumber_=pktcounter;
   hdr->packetSize_=packetSize_;
   hdr->NumPacks_=NumPacks_; 
   hdr->interval_=interval_;
	hdr->SpreadFactor_=SpreadFactor_;
	send(p,0);
	return;
}

void pkttimer::expire(Event *e)
{
	a_->timeout(0);
}
