#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
class pktsender;
struct pktsenderHdr
{
	double sendtime_;
	double packetnumber_;
	int packetSize_;
	int NumPacks_;
	double interval_;
	double SpreadFactor_;	
	//Header Access Methods
	static int offset_;
	inline static int& offset() {return offset_;}
	inline static pktsenderHdr* access(const Packet *p)
	{ return(pktsenderHdr*) p->access(offset_); }
};

class pkttimer:public TimerHandler
{
	public:
		pkttimer(pktsender *a): TimerHandler() {a_=a;}
//	protected:
		virtual void expire(Event *e);
		pktsender *a_;
};

class pktsender:public Agent
{
	public:
		//Function Declarations
		pktsender();
		virtual int command(int argc,const char*const* argv);
		virtual void timeout(int);
		virtual void sendpacket();
		
		//External Variables
		double interval_;   	// Spacing between two packets
		double WaitInterval_;   // Spacing between two streams
		int NumPacks_;    	// Number of packets in a stream
		int packetSize_;  	// Size of the payload in bytes
		double SpreadFactor_;  	// If we want the successive packet spacings to change
		double MaxRate_;
		double MinRate_;
		pkttimer timer_;	//Timer for mainitaing the clock
		//Internal Variables
		int pktcounter;  	//Internal counter to be used only by the agent
		double EndInterval; //Interval after which you should stop sending packets
		double StartInterval; //Interval at which ou tart sending packets
};

