#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include <math.h>
class pktreceiver;

struct pktsenderHdr
{
        double sendtime_;
        double packetnumber_;
        int packetSize_;
        int NumPacks_;
        double interval_;
        double SpreadFactor_;
        //Header Access Methods
        static int offset_;
        inline static int& offset() {return offset_;}
        inline static pktsenderHdr* access(const Packet *p)
        { return(pktsenderHdr*) p->access(offset_); }
};

struct pktreceiverHdr
{
	double sendtime_;
	double packetnumber_;
	int packetSize_;
	int NumPacks_;	
	//Header Access Methods
	static int offset_;
	inline static int& offset() {return offset_;}
	inline static pktreceiverHdr* access(const Packet *p)
	{ return(pktreceiverHdr*) p->access(offset_); }
};

class pktreceiver:public Agent
{
	public:
	//Function Declarations
		pktreceiver();
		virtual int start();
		virtual int command(int argc,const char*const* argv);
		virtual void recv(Packet*,Handler*); 
		void allocatemem();
		void freemem();
		double computeavabw();
	//External Variables
		double interval_;
		int NumPacks_;
		int packetSize_;
		double decrease_factor_;
		double samples_for_ab_;
		double Excursion_Threshold_;
	//Internal Variables	
		double *qing_delay;
		double *rates;
		double *iat;
		double *av_bw_per_pkt;
		double senderPacks_;
		double *circular;
		int head;
		int tail;
		int samples;
		int full;
};
