#include "pktreceiver.h"

int pktreceiverHdr::offset_;
static class pktreceiverHdrClass: public PacketHeaderClass
{
	public:
	pktreceiverHdrClass(): PacketHeaderClass("PacketHeader/pktreceiver",sizeof(pktreceiverHdrClass))
	{
		bind_offset(&pktreceiverHdr::offset_);
	}

}class_pktreceiverHdr;

static class pktreceiverClass: public TclClass
{
	public:
		pktreceiverClass():TclClass("Agent/pktreceiver"){}
		TclObject* create(int,const char*const*)
		{
			return (new pktreceiver());
		}
}class_pktreceiver;

pktreceiver::pktreceiver():Agent(PT_PKTRECEIVER)
{
	bind("interval_",&interval_);
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
	bind("decrease_factor_",&decrease_factor_);
	bind("samples_for_ab_",&samples_for_ab_);
	bind("Excursion_Threshold_",&Excursion_Threshold_);
	full=0;
	head=0;
	tail=0;
	samples=0;
}

int pktreceiver::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

int pktreceiver::start()
{
	// right now we are not doing anything
	// allocate the memory for some data structures
	int samples=(int)samples_for_ab_;
	circular=(double *)calloc(samples,sizeof(double));
}

void pktreceiver::recv(Packet *pkt,Handler*)
{
	hdr_ip* hdrip = hdr_ip::access(pkt);
	pktsenderHdr *h=pktsenderHdr::access(pkt);
	int index=(int)h->packetnumber_;
 	double spread=h->SpreadFactor_;
	double interval_=h->interval_;
	int spacketsize=h->packetSize_;
	senderPacks_=h->NumPacks_;
	//fprintf(stdout,"RAll1 %lf %d %lf \n",h->sendtime_,h->packetSize_,h->packetnumber_);
   	fprintf(stdout,"Packet Number %d ",index);
	if(h->packetnumber_==0)
	{
		allocatemem();
		double temptime=Scheduler::instance().clock();
		qing_delay[index]=(temptime)-(h->sendtime_);	
		fprintf(stdout,"Rcv Time %lf Snd Time %lf \n",temptime,h->sendtime_);
		//qing_delay[index]=(Scheduler::instance().clock())-(h->sendtime_);	
		//Alok Changed to 
		rates[index]=interval_;
		iat[index]=(double)(((8*spacketsize)/interval_));
		
		//Orginal was
		//iat[index]=(interval_);
		//rates[index]= (double)((8*spacketsize)/(interval_))/1000000;
		
		//fprintf(stdout," First Quing %lf \n",qing_delay[index],iat[index]);
		fprintf(stdout,"Interval %lf Spread %1.9lf Quing %1.9lf \n",interval_,spread,qing_delay[index]);
		fprintf(stdout,"Rates %1.9lf IAT %1.9lf \n",rates[index],iat[index]);
	}
	else
	{
		double temptime=Scheduler::instance().clock();
		qing_delay[index]=(temptime)-(h->sendtime_);	
		fprintf(stdout,"Rcv Time %lf Snd Time %lf \n",temptime,h->sendtime_);
		double decrease=1;
     	for(int i=0;i<(index);i++)
     	{ 
     		decrease=decrease*spread;
     	}
		//Alok Changed to 
		rates[index]=(interval_*decrease);
		iat[index]=(double)(((8*spacketsize)/interval_*decrease));
		//Orginally this
		//iat[index]=(interval_*decrease);
		//rates[index]= (double)((8*spacketsize)/(interval_*decrease))/1000000;
		
		fprintf(stdout,"Interval %lf Spread %1.9lf Quing %1.6lf \n",interval_,spread,qing_delay[index]);
		fprintf(stdout,"Rates %1.9lf IAT %1.6lf \n",rates[index],iat[index]);
	}
	if(h->packetnumber_==(senderPacks_-1))
	{
		fprintf(stdout," Compute Called \n");
		double inst_abw=computeavabw();
		double time=Scheduler::instance().clock();
		fprintf(stdout,"%lf: InstAvailable Bandwidth is %lf\n",time,inst_abw);
		freemem();
		fprintf(stdout," Alok %d %d \n",tail,samples_for_ab_);
		circular[tail]=inst_abw;
		samples++;
		tail++;
		if(tail>samples_for_ab_) tail=0;
		if(samples>(samples_for_ab_-1))
		{
			double sum;	
			for(int i=0;i<samples_for_ab_;i++)
			{
				sum=sum+circular[i];
				fprintf(stdout," %d Puts %lf ",i,circular[i]);
			}
			double MovAb=sum/samples_for_ab_;
			double time=Scheduler::instance().clock();
			fprintf(stdout,"SUM BW is %lf \n",sum);
			fprintf(stdout,"%lf Moving Available BW is %lf \n",time,MovAb);
			samples=0;
			tail=0;
		}
	}
	Packet::free(pkt);
}

void pktreceiver::allocatemem()
{
	fprintf(stdout,"In allocate Mem %d \n",NumPacks_);
	//int TempNumPacks_=100;
	int TempNumPacks_=NumPacks_;
	qing_delay=(double *) calloc((int)(TempNumPacks_),sizeof(double));
	rates=(double *) calloc((int)(TempNumPacks_),sizeof(double));
	iat=(double *) calloc((int)(TempNumPacks_),sizeof(double));
	av_bw_per_pkt=(double *) calloc((int)(TempNumPacks_),sizeof(double));
}	

void pktreceiver::freemem()
{
	fprintf(stdout,"In free Mem %d \n",NumPacks_);
	free(qing_delay);
	free(rates);
	free(iat);
	free(av_bw_per_pkt);
}	

double pktreceiver::computeavabw()
{
	int loc=0,exstart=0,exend=0;
	double sum_iat, sum_abw;
	double maxq=0;
	sum_abw=0;
	sum_iat=0;
	//Look for first excursion
	while((qing_delay[exstart]>=(qing_delay[exstart+1]))&&(loc<NumPacks_))
		exstart++;
	
	//Alo Changed
	loc=exstart+1;

	fprintf(stdout," First Location Found %d \n",exstart); 
	while(loc<senderPacks_)
	{
		if(maxq<(qing_delay[loc]-qing_delay[exstart]))
			maxq=qing_delay[loc]-qing_delay[exstart];
		
		// Chk to see if the qing delay has decreased	
		if((qing_delay[loc]-qing_delay[exstart])<(maxq/decrease_factor_))
		{
			//fprintf(stdout," Inside loop \n");
			// If we enter this condition.. the excursion has ended
			// If greater than this threshold then worthwhile 
			// Else might be noise
			if((loc-exstart) >= Excursion_Threshold_)
			{
				//Mark all increasing periods as having AB equal to their
				//Rates
				printf("Excursion Found at %d \n",exstart);
				for(int count=exstart;count<loc-1;count++)
				{
					if(qing_delay[count]<qing_delay[count+1])
						av_bw_per_pkt[count]=rates[count];
				}
			}
			exstart=loc;
			while((qing_delay[exstart]>=qing_delay[exstart+1])&&(loc<NumPacks_))
				exstart++;	
			loc=exstart;
			printf(" Exstart changes %d \n",exstart); 
			maxq=0.0;
		}
		loc++;
	}
	//For the last excursion let all be the same as the sending rate for the first
	if(exstart==senderPacks_)
		exstart--;
	for(int counter=exstart;counter<senderPacks_;counter++)
	{
		//fprintf(stdout," Setting Rates\n");
		printf("Excursion Found at %d \n",exstart);
		av_bw_per_pkt[counter]=rates[exstart];
	}
	//Compute the AB from the rates equation
	for(int count=0;count<(senderPacks_-1);count++)
	{
		if(av_bw_per_pkt[count]<1.0)
			av_bw_per_pkt[count]=rates[exstart];
		sum_iat=sum_iat+iat[count];
		printf("Debug bw per pkt %lf and iat %lf \n",av_bw_per_pkt[count],iat[count]);
		sum_abw=sum_abw+av_bw_per_pkt[count]*iat[count];
		fprintf(stdout," Abw per packet is %lf %lf \n",av_bw_per_pkt[count],iat[count]);
	}
	printf("Debug_____________________________\n");
	fprintf(stdout,"Sum IAT %lf and Sum ABW %lf \n",sum_iat, sum_abw);
	sum_abw=sum_abw/sum_iat;
	fprintf(stdout,"Returning back %lf \n",sum_abw);
	return sum_abw;
}		
