#include "pktsender.h"

int pktsenderHdr::offset_;
static class pktsenderHdrClass: public PacketHeaderClass
{
	public:
	//pktsenderHdrClass(): PacketHeaderClass("PacketHeader/pktsender",sizeof(pktsenderHdrClass))
	pktsenderHdrClass(): PacketHeaderClass("PacketHeader/pktsender",sizeof(pktsenderHdr))
	{
		bind_offset(&pktsenderHdr::offset_);
	}

}class_pktsenderHdr;

static class pktsenderClass: public TclClass
{
	public:
		pktsenderClass():TclClass("Agent/pktsender"){}
		TclObject* create(int,const char*const*)
		{
			return (new pktsender());
		}
}class_pktsender;

pktsender::pktsender():Agent(PT_PKTSENDER),timer_(this)
{
	bind("interval_",&interval_);
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
	bind("WaitInterval_",&WaitInterval_);
	bind("SpreadFactor_",&SpreadFactor_);
	bind("MaxRate_",&MaxRate_);
	bind("MinRate_",&MinRate_);
	pktcounter=0;
}

int pktsender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			StartInterval=(8*size_)/(MinRate_);
			EndInterval=(8*size_)/(MaxRate_);
			interval_=StartInterval;
			//int Packs=(int)((log(MinRate_/MaxRate_)/log(1/SpreadFactor_))+2);
			int Packs=(int)((log(MinRate_/MaxRate_)/log(1/SpreadFactor_))+2);
			NumPacks_=Packs;
			fprintf(stdout,"Max %lf and Min %lf %lf %lf %d \n",MaxRate_,MinRate_,StartInterval,EndInterval,Packs);
			timeout(0);
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void pktsender::timeout(int)
{
	packetSize_=size_;
	sendpacket();
	pktcounter++;
	if(pktcounter==NumPacks_)
	//if(interval_<=EndInterval) 
	{
		fprintf(stdout," Chirp Sent \n");
		pktcounter=0;
		interval_=StartInterval;
		timer_.resched(WaitInterval_);
	}
	else
	{
		double decrease=1;
		for(int i=0;i<(pktcounter-1);i++)
		{
			decrease=decrease*SpreadFactor_;	
		}
		//Alok Changed this //
		double currentrate=MinRate_*decrease;
		interval_=(8*size_)/currentrate;
		//This was orginal 
		//interval_ = StartInterval*decrease;	
		timer_.resched(interval_);
	}
}

void pktsender::sendpacket()
{
	Packet *p=allocpkt();
	pktsenderHdr *hdr=pktsenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
	hdr->packetnumber_=pktcounter;
  	hdr->packetSize_=packetSize_;
  	hdr->NumPacks_=NumPacks_; 
  	//Alok Changed this 
	hdr->interval_=MinRate_;
	//Orginally this
	//hdr->interval_=StartInterval;
	
	hdr->SpreadFactor_=SpreadFactor_;
	//fprintf(stdout,"SAll1 %lf %d %lf \n",hdr->sendtime_,hdr->packetSize_,hdr->packetnumber_);
	//fprintf(stdout,"SAll2 %d %lf %lf \n",hdr->NumPacks_,hdr->interval_,hdr->SpreadFactor_);
	//fprintf(stdout,"S1 %lf \n",hdr->sendtime_);
	//fprintf(stdout,"S2 %d \n",hdr->packetSize_);
	//fprintf(stdout,"S3 %lf \n",hdr->packetnumber_);
   //fprintf(stdout,"S4 %d \n",hdr->NumPacks_);
   //fprintf(stdout,"S5 %lf \n",hdr->interval_);
   //fprintf(stdout,"S6 %lf \n",hdr->SpreadFactor_);
	send(p,0);
	return; 
}

void pkttimer::expire(Event *e)
{
	a_->timeout(0);
}
