#include "pktreceiver.h"
int ploadreceiverHdr::offset_;
static class ploadreceiverHdrClass: public PacketHeaderClass
{
        public:
        ploadreceiverHdrClass(): PacketHeaderClass("PacketHeader/pathload_rcvr",sizeof(ploadreceiverHdrClass))
        {
                bind_offset(&ploadreceiverHdr::offset_);
        }

}class_ploadreceiverHdr;

static class ploadreceiverClass: public TclClass
{
	public:
		ploadreceiverClass():TclClass("Agent/pathload_rcvr"){}
		TclObject* create(int,const char*const*)
		{
			return (new ploadreceiver());
		}
}class_ploadreceiver;

ploadreceiver::ploadreceiver():Agent(PT_PATHLOADRCVR)
{
	bind("interval_",&interval_);
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
	bind("samples_for_ab_",&samples_for_ab_);  
	bind("Resolution_",&Resolution_);
	bind("Threshold_",&Threshold_);
	// This has no role so far
	bind("decrease_factor_",&decrease_factor_);
	bind("Excursion_Threshold_",&Excursion_Threshold_);
	reset();
}
void ploadreceiver::reset()
{
	fleetcounter=0;
	Gmax=0;
	Gmin=0;
	Rmax=0;
	Rmin=0;
	Rcur=0;
	Init=0;
	RmaxSet=0;
	RminSet=0;
}

int ploadreceiver::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

int ploadreceiver::start()
{
	senderPacks_=NumPacks_;
	packetSize_=size_;
	allocaterunmem();
	allocatemem();
}

void ploadreceiver::recv(Packet *pkt,Handler*)
{
	hdr_ip* hdrip = hdr_ip::access(pkt);
	ploadsenderHdr *h=ploadsenderHdr::access(pkt);
	int index=(int)h->packetnumber_;
 	double spread=h->SpreadFactor_;
	double interval_=h->interval_;
	int spacketsize=h->packetSize_;
	senderPacks_=h->NumPacks_;
	int ptype=h->type;
	// This is the data collection part
	if(fleetcounter==0)
	{
		//Allocate Memory
		EnSquared=(int)sqrt(senderPacks_);
	}
	
	if(h->packetnumber_==0)
	{
		rcv_time[index]=Scheduler::instance().clock();	
		qing_delay[index]=(rcv_time[index])-(h->sendtime_);
		snd_time[index]=h->sendtime_;
		if(ptype==1)
			fprintf(stdout," index %d Recorded this value %lf\n",index,rcv_time[index]);
	}
	else
	{
		rcv_time[index]=Scheduler::instance().clock();	
		qing_delay[index]=(rcv_time[index])-(h->sendtime_);	
		snd_time[index]=h->sendtime_;
		iat[index]=qing_delay[index]-qing_delay[index-1];
		rates[index]= (double)((8*spacketsize)/(interval_))/1000000;
	}
	
	
	// End data collection part
	// Inference Logic Part here 
	if(h->packetnumber_==(senderPacks_-1))
	{
		if(ptype==1)
		{
			double adr=computeadr(spacketsize);
			//adr=10000000;
			Rcur=adr;
			fprintf(stdout,"The ADR is %lf \n",adr);
			sendresponse(adr,1);
		}
		else if(ptype==2)
		{			
			orderowds();
			computepctandpdt();
			fleetcounter++;
			for (int ho=0;ho<fleetcounter;ho++)
			{
				//fprintf(stdout,"AlDebug pct %lf pdt %lf \n",pct[ho],pdt[ho]);
			}
			//fprintf(stdout,"Fleet Recd %d\n ",fleetcounter);
			if(fleetcounter==samples_for_ab_)
			{
				//fprintf(stdout,"Last stream recd to make inference \n");
				fleetcounter=0;
				//the bit about computing the AB here
				int resp=gettrend();
				//fprintf(stdout," Got the Trend %d \n",resp);
				double nextrate=nextsendingrate(resp);
				Rcur=nextrate;
				if(nextrate<0)
				{
					//Print the Available Bandwidth
					double timeofMeasure=Scheduler::instance().clock();
			fprintf(stdout," %lf Available Bandwidth is  %lf %lf %lf %lf \n",timeofMeasure,Rmax,Rmin,Gmax,Gmin);
					reset();
				}
				sendresponse(nextrate,2);
				fprintf(stdout," Sent Response %lf \n\n",nextrate);
				
			}
			else
			{
				sendresponse(0,2);
				fprintf(stdout," Sent Response  0\n\n");
			}
		}
		//freemem();
	}
	Packet::free(pkt);
}

void ploadreceiver::orderowds()
{
	int Esqrt=(int)sqrt(senderPacks_);
	int counter=0;

	//for(int i=0;i<senderPacks_;i++)
	//	fprintf(stdout,"Debugging Packet %d QingD %lf \n",i,qing_delay[i]);
	
	for(int i=0;i<senderPacks_;i=i+Esqrt)
	{
		int start=i;
		int end=i+Esqrt;
		for(int j=start;j<end;j++)
		{
			for(int k=start;k<end;k++)
			{
				if(qing_delay[k]>qing_delay[k+1])
				{
					double temp=qing_delay[k];
					qing_delay[k]=qing_delay[k+1];
					qing_delay[k+1]=temp;
				}
			}
		}
		/***Computing the median*****/
		double median;
		if(Esqrt%2==0)
		{
		 	median=(qing_delay[i+Esqrt/2]+qing_delay[(i+Esqrt/2)-1])/2;
		}
		else
		{
			median=qing_delay[i+Esqrt/2];	
		}
		ordered[counter]=median;
		fprintf(stdout,"Ordered %lf \n",ordered[counter]);
		counter++;
	}			
}

void ploadreceiver::computepctandpdt()
{
	int Esqrt=(int)sqrt(senderPacks_);
	int alokcount=0;	
	for(int i=1;i<Esqrt;i++)
	{
		int temp1=(int)(ordered[i]*1000000);
		int temp2=(int)(ordered[i-1]*1000000);
		//fprintf(stdout," Comparing %1.8lf and %1.8lf \n",ordered[i],ordered[i-1]);
		//fprintf(stdout," Comparing %d and %d \n",temp1,temp2);
		//if(ordered[i]>ordered[i-1])
		if(temp1>temp2)
		{
			//fprintf(stdout," Condiion Satisfied \n");
			//if(temp1==temp2) fprintf(stdout," Equalit check \n");
			alokcount++;
		}
	}
	double pctmetric=alokcount/(Esqrt-1);
	
	double sum=0;
	for(int i=1;i<Esqrt;i++)
	{
		sum=sum+fabs(ordered[i]-ordered[i-1]);
	}
	double pdtmetric;
	if(sum!=0)
	{
		//fprintf(stdout," We get this %lf %lf \n",(ordered[Esqrt-1]-ordered[0]),sum);
		pdtmetric=((ordered[Esqrt-1]-ordered[0])*100000)/(sum*100000);
		if((ordered[Esqrt-1]-ordered[0])<.00001)
		{
			//fprintf(stdout," Corrected pdtmetric \n");
			pdtmetric=0;
		}
		if(sum<.00001) 
		{
			fprintf(stdout," Corrected pdtmetric \n");
			pdtmetric=0;
		}
	}
	else
	{
		pdtmetric=0;
	}					
	
	//fprintf(stdout,"In Loop act PCT %lf PDT %lf fleetcounter %d\n",pctmetric,pdtmetric,fleetcounter);
	
	if(pctmetric>.66)
	{
		pct[fleetcounter]=1;
	}
	else if (pctmetric<.55)
	{
		pct[fleetcounter]=-1;
	}
	else
	{
		pct[fleetcounter]=0;
	}
	
	if(pdtmetric>.55)
	{
		pdt[fleetcounter]=1;
	}
	else if(pdtmetric<.45)
	{
		pdt[fleetcounter]=-1;
	}
	else
	{
		pdt[fleetcounter]=0;
	}
	//fprintf(stdout,"In Loop PCT %lf PDT %lf \n",pct[fleetcounter],pdt[fleetcounter]);
	for (int ho=0;ho<fleetcounter;ho++)
	{
	//	fprintf(stdout,"AlDebugSoFar  pct %lf pdt %lf \n",pct[ho],pdt[ho]);
	}
}

int ploadreceiver::gettrend()
{
	int inc=0,no=0,discard=0;
	//fprintf(stdout," In GetTrend \n");
	for(int i=0;i<samples_for_ab_;i++)
	{
		fprintf(stdout,"Get Trend %d PCT %lf and PDT %lf \n",i,pct[i],pdt[i]);
		if(pct[i]==1)
		{
			if((pdt[i]==1)||(pdt[i]==0))
			{
				inc++;
			}
			else
			{
				discard++;
			}
		}
		
		if(pct[i]==-1)
		{
			if((pdt[i]==-1)||(pdt[i]==0))
			{
				no++;
			}
			else
			{
				discard++;
			}
		}
		
		if(pct[i]==0)
		{
			if(pdt[i]==1)
			{
				inc++;
			}
			else if(pdt[i]==-1)
			{
				no++;
			}
			else
			{
				discard++;
			}
		}
	}
	int valid=(int)(samples_for_ab_-discard);
	if(valid==0) return 0;
	double iratio=(double)inc/(double)valid;
	double nratio=(double)no/(double)valid;
	fprintf(stdout,"Hello inc-> %d no-> %d discard->%d \n",inc,no,discard);
	fprintf(stdout," I saw valid %d %lf %lf\n",valid,iratio,nratio);
	if((iratio)>Threshold_)
	{
		fprintf(stdout," I retruned 1 Threshold %lf \n",Threshold_);
		return 1;  	//Increasing
	}
	else if((nratio)>Threshold_)
	{
		fprintf(stdout," I retruned -1 Threshold %lf \n",Threshold_);
		return -1; 	//Non Increasing
	}	
	else
	{
		fprintf(stdout," I retruned 0 Threshold %lf \n",Threshold_);
		return 0;  	//Grey 
	}
}

double ploadreceiver::nextsendingrate(int trend)
{
	double next;
	// means that Rmax or Rmin are 0
	if(Init==0)	
	{
		if(trend==1)
		{
			Rmax=Rcur;
			next=Rmax/2;
			RmaxSet=1;
			fprintf(stdout," Inited Current was %lf::saw Inc Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
		if(trend==-1)
		{
			Rmin=Rcur;
			next=Rmin*2;
			RminSet=1;
			fprintf(stdout," Inited Current was %lf::saw Non-Inc Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
		if(trend==0)
		{
			if(Rmax==0)
				next=Rcur*2;
			if(Rmin==0)
				next=Rcur/2;
			fprintf(stdout," Inited Current was %lf::saw Grey Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
		if((RmaxSet==1)&&(RminSet==1))
		{
			Init=1;
			next=(Rmax+Rmin)/2;
			fprintf(stdout," All Inited %lf::saw Grey Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
	}
	else
	{

		if(trend==1)
		{
			Rmax=Rcur;
			if(Gmax>0)
			{
				next=(Rmax+Gmax)/2;
			}
			else
			{
				next=(Rmax+Rmin)/2;
			}	
			fprintf(stdout,"Current was %lf::saw Inc Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
		else if (trend==-1)
		{
			Rmin=Rcur;
			if(Gmin>0)
			{
				next=(Gmin+Rmin)/2;
			}
			else
			{
				next=(Rmax+Rmin)/2;
			}	
			fprintf(stdout,"Current was %lf::saw Non-Inc Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
		else if (trend==0)
		{
			if((Gmin==0)&&(Gmax==0))
			{
				//fprintf(stdout," Cond1 \n");
				Gmin=Rcur;
				Gmax=Rcur;
			}
			
			if((Rmax-Gmax)>Resolution_)
			{
				//if((Gmax<=Rcur))
				//{
					//fprintf(stdout," Cond2 \n");
					Gmax=Rcur;
					next=(Rmax+Gmax)/2;
				//}
			}
			else if((labs(Rmin-Gmin)>Resolution_))
			{
				//if(Gmin>Rcur)
				//{
					//fprintf(stdout," Cond3 \n");
					Gmin=Rcur;
					next=(Rmin+Gmin)/2;
				//}
			}
		fprintf(stdout,"Current was %lf::saw Grey Trend V %lf %lf %lf %lf Next is %lf \n",Rcur,Rmax,Rmin,Gmax,Gmin,next);
		}
		//Violation of Rmax, Gmax Gmin Rmin order
		if(Rmax<Gmax) {Gmax=0;Gmin=0; }
		if(Rmax<Gmin) {Gmin=0;Gmin=0; }
		if(Rmin>Gmax) {Gmax=0;Gmin=0; }
		if(Rmin>Gmin) {Gmax=0;Gmin=0; }
		if((Rmax-Rmin)<=Resolution_)
		{
			fprintf(stdout," Type 1\n");
			next=-10000;
			return(next);
		}
		if(((labs(Gmin-Rmin))<=Resolution_)&&((Rmax-Gmax)<=Resolution_))
		{
			fprintf(stdout," Type 2\n");
			next=-100000;
			return(next);
		}
	}	
	//fprintf(stdout," Leaving Function \n\n\n");
	return(next);
}	


void ploadreceiver::allocatemem()
{
	//Set SenderPacks_= 4000
	//int tempsenderPacks_=senderPacks_;	
	int tempsenderPacks_=4000;	
	int Esqrt=(int)sqrt(tempsenderPacks_);
	
	qing_delay=(double*) calloc(tempsenderPacks_,sizeof(double));
	if(!qing_delay) fprintf(stdout," \n\nERROR\n\n");

	rates=(double*)calloc(tempsenderPacks_,sizeof(double));
	if(!rates) fprintf(stdout," \n\nERROR\n\n");

	iat=(double*)calloc(tempsenderPacks_,sizeof(double));
	if(!iat) fprintf(stdout," \n\nERROR\n\n");

	av_bw_per_pkt=(double*) calloc(tempsenderPacks_,sizeof(double));
	if(!av_bw_per_pkt) fprintf(stdout," \n\nERROR\n\n");

	snd_time=(double*)calloc(tempsenderPacks_,sizeof(double));
	if(!snd_time) fprintf(stdout," \n\nERROR\n\n");

	rcv_time=(double*)calloc(tempsenderPacks_,sizeof(double));
	if(!rcv_time) fprintf(stdout," \n\nERROR\n\n");

	ordered=(double*)calloc((int)Esqrt,sizeof(double));
	if(!ordered) fprintf(stdout," \n\nERROR\n\n");
		
}	

void ploadreceiver::allocaterunmem()
{
	pct=(double *) calloc((int)(samples_for_ab_),sizeof(double));
	if(!pct) fprintf(stdout," \n\nERROR\n\n");
	
	pdt=(double *) calloc((int)(samples_for_ab_),sizeof(double));
	if(!pdt) fprintf(stdout," \n\nERROR\n\n");
}
void ploadreceiver::freemem()
{
	if(qing_delay) free(qing_delay);
	if(rates) free(rates);
	if(iat) free(iat);
	if(av_bw_per_pkt) free(av_bw_per_pkt);
	if(ordered) free(ordered);
	if(snd_time) free (snd_time);
	if(rcv_time) free (rcv_time);
}

void ploadreceiver::freerunmem()
{
	if(pct) free(pct);
	if(pdt) free(pdt);
}

double ploadreceiver::computeadr(int spacketsize)
{
	int last=(int)(senderPacks_-1);
	double delta=rcv_time[last]-rcv_time[0];
	double adr=(spacketsize*8*senderPacks_)/delta;
	fprintf(stdout,"last %d last rtime %lf first rtime %lf \n",last,rcv_time[last],rcv_time[0]);
	return adr;	 	
}

void ploadreceiver::sendresponse(double newrate,int type)
{
   	Packet *p=allocpkt();
   	ploadreceiverHdr *hdr=ploadreceiverHdr::access(p);
  	hdr->sendtime_=Scheduler::instance().clock();
	hdr->ack_=0;
	hdr->newPacketSize_=1500;   // This will change
	hdr->responseType_=type;    
	hdr->feedback_=newrate;
	hdr->loss_=0;              // This will change
	hdr->terminate_=0; 	      // This will change
   	send(p,0);
	//Packet::free(p);
        return;
}

double ploadreceiver::computeavabw()
{
}		
