#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include <math.h>
class ploadreceiver;
struct ploadsenderHdr
{
        int NumPacks_;
        int packetSize_;
        double interval_;
        double SpreadFactor_;
        double WaitInterval_;
        double sendtime_;
        double packetnumber_;
        double Max_rate_;
        int type;  //packet belongs to train or stream 1 train 2 stream
//Header Access Methods
        static int offset_;
        inline static int& offset() {return offset_;}
        inline static ploadsenderHdr* access(const Packet *p)
        { return(ploadsenderHdr*) p->access(offset_); }
};

struct ploadreceiverHdr
{
	double sendtime_;
	int ack_;// Acknowledges the complete rx of a certin numbered fleet
	int newPacketSize_;  //Tells sender of what is the next packet size to use
	int responseType_ ; // 1 reponse to train 2 response to fleet
	double feedback_ ; //Feedback to sx .. usually new sx rate
	int loss_;    // set if loss observed
	int terminate_; // end the measurement and report the abw
//Header Access Methods
	static int offset_;
	inline static int& offset() {return offset_;}
	inline static ploadreceiverHdr* access(const Packet *p)
	{ return(ploadreceiverHdr*) p->access(offset_); }
};

class ploadreceiver:public Agent
{
	public:
	//Function Declarations
		ploadreceiver();
		virtual int start();
		virtual int command(int argc,const char*const* argv);
		virtual void recv(Packet*,Handler*); 
		void allocaterunmem();
		void allocatemem();
		void freemem(); 
		void freerunmem(); 
		double computeadr(int);
		double computeavabw();
		void sendresponse(double,int);
		void orderowds();
		void computepctandpdt();
		int gettrend();
		double nextsendingrate(int);
		void reset();
	//External Variables
		double interval_;   	// Set by sender
		int NumPacks_; 		// Set by user.. should correlate with sender 
		int packetSize_;	// Set by user this is the packet size of returning packet	
		double decrease_factor_;
		double samples_for_ab_;
		double Threshold_;
		double Resolution_;
		double Excursion_Threshold_;
	//Internal Variables	
		int fleetcounter;
		int EnSquared;
		double *qing_delay;
		double *rates;
		double *iat;
		double *av_bw_per_pkt;
		double *snd_time;
		double *rcv_time;
		double senderPacks_;  	//Set by the sender 
		int Init;		// If both rmax and rmin have been set
		int RmaxSet;	// If Rmax has been set
		int RminSet; 	// If Rmin has been set
		double Gmax;
		double Gmin;
		double Rmax;
		double Rmin;
		double Rcur;
	//Unique to pathload
		double *ordered;  	// This is the palce where ordered owd are stored
		double *pct;		// This is the place where the pct metric per fleet are stored
		double *pdt;		// This is the place where the pdt metric per fleet are stored
		
};
