#include "pktsender.h"

int ploadsenderHdr::offset_;
static class ploadsenderHdrClass: public PacketHeaderClass
{
	public:
	ploadsenderHdrClass(): PacketHeaderClass("PacketHeader/pathload_sndr",sizeof(ploadsenderHdrClass))
	{
		bind_offset(&ploadsenderHdr::offset_);
	}

}class_ploadsenderHdr;

static class ploadsenderClass: public TclClass
{
	public:
		ploadsenderClass():TclClass("Agent/pathload_sndr"){}
		TclObject* create(int,const char*const*)
		{
			return (new ploadsender());
		}
}class_ploadsender;

ploadsender::ploadsender():Agent(PT_PATHLOADSNDR),timer_(this)
{
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
   	bind("interval_",&interval_);
   	bind("SpreadFactor_",&SpreadFactor_);
   	bind("WaitInterval_",&WaitInterval_);
	bind("Max_rate_",&Max_rate_);
	bind("MT_",&MT_);
	pktcounter=0;
	fleetcounter=0;
	packetSize_=size_;   				//Store the ideal packet size in packetSize_
	NumPacksSet=NumPacks_;			 	// Store the ideal NumPacks_ value
}

int ploadsender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void ploadsender::start()
{
	size_=packetSize_;   				//Set packetsize to be max packet size
	NumPacks_=NumPacksSet;
	//Figure out number of Packets
	fprintf(stdout," First Number of packs %d \n",NumPacks_);
	int PackSize=(int)(MT_*Max_rate_)/(NumPacks_*8);
	if (PackSize<96)
	{
		PackSize=96;
		int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
		double temp=round(sqrt(numpacks));
		numpacks=(int)(temp*temp); //Temp Variable
		NumPacks_=numpacks;
	}
	if (PackSize>8192)
	{
		PackSize=8192;
		int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
		double temp=round(sqrt(numpacks));
		numpacks=(int)(temp*temp); //Temp Variable
		NumPacks_=numpacks;
	}
	size_=PackSize;
	currinterval=((size_*8)/(Max_rate_));	// Interval for Maximum Rate	
	fprintf(stdout," Number of packs %d Pack Size %d Interval %lf\n",NumPacks_,size_,currinterval);
	status=1;
	timeout(0);
}

void ploadsender::timeout(int)
{
	if(status==1)
	{
		sendtrain(1);  //Send with train flag set
	}
	else if(status==2)
	{
		sendtrain(2);  // Send with fleet flag set
	}
	return ;
}

void ploadsender::sendtrain(int type)
{
	sendpacket(type);
	pktcounter++;
	if(pktcounter==NumPacks_)
	{
		//The train or the fleet ends
		pktcounter=0;
		status=0;  
	}
	else
	{
		timer_.resched(currinterval);
	}
	return;
}

void ploadsender::sendpacket(int typepack)
{
	Packet *p=allocpkt();
	ploadsenderHdr *hdr=ploadsenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
   	hdr->NumPacks_=NumPacks_; 
   	hdr->packetSize_=size_;
   	hdr->interval_=currinterval;
	hdr->SpreadFactor_=SpreadFactor_;
  	hdr->Max_rate_=Max_rate_;
	hdr->WaitInterval_=WaitInterval_;
	hdr->packetnumber_=pktcounter;
	hdr->type=typepack;
	send(p,0);
	return;
}

//The receiver module
void ploadsender::recv(Packet *recvpkt ,Handler*)
{
	// this is where a response will come back .. 
	fprintf(stdout," Sender Module:: In recv \n\n\n");
	hdr_ip* hdrip = hdr_ip::access(recvpkt);
   	ploadreceiverHdr *h=ploadreceiverHdr::access(recvpkt);
	double fb=h->feedback_;
	Packet::free(recvpkt);	
	if(fb>0)
	{	
		fprintf(stdout," Sender Module:: Recd Packet feedback is %lf \n",fb);
		size_=packetSize_;   				//Set packetsize to be max packet size
		NumPacks_=NumPacksSet;
		int PackSize=(int)(MT_*fb)/(NumPacks_*8);
		if (PackSize<96)
		{
			PackSize=96;
			int numpacks=(int)(MT_*fb)/(PackSize*8);
			double temp=round(sqrt(numpacks));
			numpacks=(int)(temp*temp); //Temp Variable
			NumPacks_=numpacks;
		}
		if (PackSize>8192)
		{
			PackSize=8192;
			int numpacks=(int)(MT_*Max_rate_)/(PackSize*8);
			double temp=round(sqrt(numpacks));
			numpacks=(int)(temp*temp); //Temp Variable
			NumPacks_=numpacks;
		}
		size_=PackSize;
		currinterval=((size_*8)/(fb));
		fprintf(stdout," Sender Module::Number of packs %d Pack Size %d Interval %lf\n",NumPacks_,size_,currinterval);
		status=2;
		sendtrain(2);
	}
	else if (fb==0)
	{
		status=2;
		sendtrain(2);
	}
	else
	{
		//BW process is over restarting it 
		pktcounter=0;
		fleetcounter=0;
		start();
		return;
	}
	return;		
}

void ploadsndtimer::expire(Event *e)
{
	a_->timeout(0);
}
