#include "pktreceiver.h"
int sprucereceiverHdr::offset_;
static class sprucereceiverHdrClass: public PacketHeaderClass
{
        public:
        sprucereceiverHdrClass(): PacketHeaderClass("PacketHeader/spruce_rcvr",sizeof(sprucereceiverHdrClass))
        {
                bind_offset(&sprucereceiverHdr::offset_);
        }

}class_sprucereceiverHdr;

static class sprucereceiverClass: public TclClass
{
	public:
		sprucereceiverClass():TclClass("Agent/spruce_rcvr"){}
		TclObject* create(int,const char*const*)
		{
			return (new sprucereceiver());
		}
}class_sprucereceiver;

sprucereceiver::sprucereceiver():Agent(PT_SPRUCERCVR)
{
	bind("interval_",&interval_);
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
	bind("samples_for_ab_",&samples_for_ab_);  
	// This has no role so far
	bind("decrease_factor_",&decrease_factor_);
	bind("Excursion_Threshold_",&Excursion_Threshold_);
	fleetcounter=0;
	CurrentAb=0;
}

int sprucereceiver::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

int sprucereceiver::start()
{
	packetSize_=size_;
}

void sprucereceiver::recv(Packet *pkt,Handler*)
{
	hdr_ip* hdrip = hdr_ip::access(pkt);
	sprucesenderHdr *h=sprucesenderHdr::access(pkt);
	int index=(int)h->packetnumber_;
 	double spread=h->SpreadFactor_;
	double interval_=h->interval_;
	int spacketsize=h->packetSize_;
	senderPacks_=h->NumPacks_;
	LinkCapacity=h->Max_rate_;
	int ptype=h->type;
	// This is the data collection part
	if(h->packetnumber_==0)
	{
		allocatemem();
		rcv_time[index]=Scheduler::instance().clock();	
		snd_time[index]=h->sendtime_;
		qing_delay[index]=rcv_time[index]-(h->sendtime_);
	}
	else
	{
		snd_time[index]=h->sendtime_;
		rcv_time[index]=Scheduler::instance().clock();	
		qing_delay[index]=rcv_time[index]-(h->sendtime_);	
		iat[index]=qing_delay[index]-qing_delay[index-1];
		rates[index]= (double)((8*spacketsize)/(interval_))/1000000;
	}
	// End data collection part
	
	//Inference Logic Part here 
	if(h->packetnumber_==(senderPacks_-1))
	{
		fprintf(stdout," Pair Recd %d \n",fleetcounter); 
		if(fleetcounter==samples_for_ab_)
		{
			//display the ab computed here
			// tell sender to stop 
			double temp=CurrentAb/samples_for_ab_;
			double timeofMeasure=Scheduler::instance().clock();
			fprintf(stdout," %lf The AB is %lf \n",timeofMeasure,temp);		
			fleetcounter=0;
			CurrentAb=0;
			//sendresponse(nextrate,2);
		}
		else
		{	
			fleetcounter++;
			computeavabw();
		}
		//freemem();
	}
	Packet::free(pkt);
}

void sprucereceiver::allocatemem()
{
	int Esqrt=(int)sqrt(senderPacks_);
	qing_delay=(double *) calloc((int)(senderPacks_),sizeof(double));
	rates=(double *) calloc((int)(senderPacks_),sizeof(double));
	iat=(double *) calloc((int)(senderPacks_),sizeof(double));
	av_bw_per_pkt=(double *) calloc((int)(senderPacks_),sizeof(double));
	snd_time=(double *) calloc((int)(senderPacks_),sizeof(double));
	rcv_time=(double *) calloc((int)(senderPacks_),sizeof(double));
	//ordered=(double *) calloc((int)(Esqrt),sizeof(double));
}	

void sprucereceiver::freemem()
{
	free(qing_delay);
	free(rates);
	free(iat);
	free(av_bw_per_pkt);
	//free(ordered);
}

double sprucereceiver::computeadr(int spacketsize)
{
	int last=(int)(senderPacks_-1);
	double delta=rcv_time[last]-rcv_time[0];
	double adr=(spacketsize*8*senderPacks_)/delta;
	return adr;	 	
}

void sprucereceiver::sendresponse(double newrate,int type)
{
        Packet *p=allocpkt();
        sprucereceiverHdr *hdr=sprucereceiverHdr::access(p);
        hdr->sendtime_=Scheduler::instance().clock();
	hdr->ack_=0;
	hdr->newPacketSize_=1500;   // This will change
	hdr->responseType_=type;    
	hdr->feedback_=newrate;
	hdr->loss_=0;              // This will change
	hdr->terminate_=0; 	   // This will change
        send(p,0);
        return;
}

double sprucereceiver::computeavabw()
{
	double deltain=snd_time[(int)(senderPacks_-1)]-snd_time[0];
	double deltaout=rcv_time[(int)(senderPacks_-1)]-rcv_time[0];
	double ratio=(deltaout-deltain)/(deltain);
	double instabw=LinkCapacity*(1-ratio);	
	CurrentAb=CurrentAb+instabw;
	fprintf(stdout,"deltain %lf and deltaout %lf \n",deltain,deltaout);
}		
