#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include <math.h>
class sprucereceiver;
struct sprucesenderHdr
{
        int NumPacks_;
        int packetSize_;
        double interval_;
        double SpreadFactor_;
        double WaitInterval_;
        double sendtime_;
        double packetnumber_;
        double Max_rate_;
        int type;  //packet belongs to train or stream 1 train 2 stream
//Header Access Methods
        static int offset_;
        inline static int& offset() {return offset_;}
        inline static sprucesenderHdr* access(const Packet *p)
        { return(sprucesenderHdr*) p->access(offset_); }
};

struct sprucereceiverHdr
{
	double sendtime_;
	int ack_;// Acknowledges the complete rx of a certin numbered fleet
	int newPacketSize_;  //Tells sender of what is the next packet size to use
	int responseType_ ; // 1 reponse to train 2 response to fleet
	double feedback_ ; //Feedback to sx .. usually new sx rate
	int loss_;    // set if loss observed
	int terminate_; // end the measurement and report the abw
//Header Access Methods
	static int offset_;
	inline static int& offset() {return offset_;}
	inline static sprucereceiverHdr* access(const Packet *p)
	{ return(sprucereceiverHdr*) p->access(offset_); }
};

class sprucereceiver:public Agent
{
	public:
	//Function Declarations
		sprucereceiver();
		virtual int start();
		virtual int command(int argc,const char*const* argv);
		virtual void recv(Packet*,Handler*); 
		void allocatemem();
		void freemem(); 
		double computeadr(int);
		double computeavabw();
		void sendresponse(double,int);
	//External Variables
		double interval_;   	// Set by sender
		int NumPacks_; 		// Set by user.. should correlate with sender 
		int packetSize_;	// Set by user this is the packet size of returning packet	
		double decrease_factor_;
		double samples_for_ab_;
		double Excursion_Threshold_;
		double link_cap_;
	//Internal Variables	
		int fleetcounter;
		int EnSquared;
		double *qing_delay;
		double *rates;
		double *iat;
		double *av_bw_per_pkt;
		double *snd_time;
		double *rcv_time;
		double senderPacks_;  	//Set by the sender
		double LinkCapacity; 
		double CurrentAb;	//Store the average AB
};
