#include "pktsender.h"

int sprucesenderHdr::offset_;
static class sprucesenderHdrClass: public PacketHeaderClass
{
	public:
	sprucesenderHdrClass(): PacketHeaderClass("PacketHeader/spruce_sndr",sizeof(sprucesenderHdrClass))
	{
		bind_offset(&sprucesenderHdr::offset_);
	}

}class_sprucesenderHdr;

static class sprucesenderClass: public TclClass
{
	public:
		sprucesenderClass():TclClass("Agent/spruce_sndr"){}
		TclObject* create(int,const char*const*)
		{
			return (new sprucesender());
		}
}class_sprucesender;

sprucesender::sprucesender():Agent(PT_SPRUCESNDR),timer_(this)
{
	bind("NumPacks_",&NumPacks_);
	bind("packetSize_",&size_);
	bind("interval_",&interval_);
	bind("SpreadFactor_",&SpreadFactor_);
	bind("WaitInterval_",&WaitInterval_);
	bind("Max_rate_",&Max_rate_);
	pktcounter=0;
	fleetcounter=0;
}

int sprucesender::command(int argc,const char*const* argv)
{
	if(argc==2)
	{
		if(strcmp(argv[1],"start")==0)
		{
			start();
			return(TCL_OK);
		}
	}
	return(Agent::command(argc,argv));
}

void sprucesender::start()
{
	packetSize_=size_;   				//Store the max packet size in packetSize_
	size_=packetSize_;   				//Set packetsize to be max packet size
	currinterval=((packetSize_*8)/(Max_rate_));	// Interval for Maximum Rate	
	fprintf(stdout,"Current Interval %lf \n",currinterval);
	status=1;
	timeout(0);
}

void sprucesender::timeout(int)
{
	if(status==1)
	{
		sendtrain(1);  //Send with train flag set
	}
	return ;
}

void sprucesender::sendtrain(int type)
{
	sendpacket(type);
	pktcounter++;
	if(pktcounter==NumPacks_)
	{
		pktcounter=0;
		timer_.resched(WaitInterval_); 
	}
	else
	{
		timer_.resched(currinterval);
	}
	return;
}

void sprucesender::sendpacket(int typepack)
{
	Packet *p=allocpkt();
	sprucesenderHdr *hdr=sprucesenderHdr::access(p);
	hdr->sendtime_=Scheduler::instance().clock();
	hdr->NumPacks_=NumPacks_; 
	hdr->packetSize_=size_;
	hdr->interval_=currinterval;
	hdr->SpreadFactor_=SpreadFactor_;
	hdr->Max_rate_=Max_rate_;
	hdr->WaitInterval_=WaitInterval_;
	hdr->packetnumber_=pktcounter;
	hdr->type=typepack;
	send(p,0);
	return;
}

//The receiver module
void sprucesender::recv(Packet *pkt ,Handler*)
{
	// this is where a response will come back .. 
	hdr_ip* hdrip = hdr_ip::access(pkt);
	sprucereceiverHdr *h=sprucereceiverHdr::access(pkt);
	double fb=h->feedback_;
	//fprintf(stdout," Received packet back and the feedback is %lf \n",fb);
	status=1;
	return;		
}

void sprucesndtimer::expire(Event *e)
{
	a_->timeout(0);
}
